use strictures 2;
use Inline::Perl6;
use Object::Remote::Node;

my $sockpath = $ARGV[0] or die "Need a listen path";

my $sock = do {
  if ($sockpath =~ /:/) {
    IO::Socket::INET->new(
      LocalAddr => $sockpath,
      Listen => 1
    ) or die "Couldn't listen to $sockpath: $!";
  } else {
    unlink($sockpath);
    IO::Socket::UNIX->new(
      Local => $sockpath,
      Listen => 1
    ) or die "Couldn't listen to $sockpath: $!";
  }
};

while (my $conn = $sock->accept) {
  local *STDIN = $conn;
  local *STDOUT = $conn;
  Object::Remote::Node->run;
}
